//---------------------------------------------------------------------------
//
//   ExportASC
//
//          Copyright(C) 1999, O.Mizno
//
//    @ASC(3D Studio ASCII)`o͂GNX|[gvOC̃TvB
//    @쐬DLL"Plugins\Export"tH_ɓKvB
//    @ASC`̂T|[g@\Ⴂ̂ƁAĎdl̏ڍׂ킩Ȃ
//    ߁ÃTvł͂܂葽̏o͂ĂȂB
//    @̌`𓯎T|[gƂ3DSgĂ邪A܂ŗȂ
//    Ŏ͂ĂȂB
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "MQPlugin.h"

BOOL SaveASC(const char *filename, MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x45601E0C;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "3D Studio Exporter   Copyright(C) 1999, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// o͗pvOCł
	return MQPLUGIN_TYPE_EXPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "3D Studio ASCII (*.asc)";
	// ̃^CvT|[gꍇ͈ȉ̂悤ɂ΂悢ÃTv
	// ł͎ĂȂ߁ARgAEg
	//case 1: return "3D Studio (*.3ds)"; 
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "asc";
	//case 1: return "3ds"; 
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQExportFile
//    [ʖŕۑ]ŕۑƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQExportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return SaveASC(filename, doc);
	//case 1: return Save3DS(filename, doc);
	}
	return FALSE;
}


// ASC`ŏo
BOOL SaveASC(const char *filename, MQDocument doc)
{
	int i, face_index, index[4], mat_index;
	MQMaterial mat;
	MQColor color;
	MQFileDialogInfo dlginfo;

	// t@C쐬EI[v
	FILE *fh = fopen(filename, "w");
	if(fh == NULL)
		return FALSE;

	// Wϊp_CAO̕\
	memset(&dlginfo, 0, sizeof(dlginfo));
	dlginfo.dwSize = sizeof(dlginfo);
	dlginfo.axis_x = MQFILE_TYPE_RIGHT;
	dlginfo.axis_y = MQFILE_TYPE_UP;
	dlginfo.axis_z = MQFILE_TYPE_BACK;
	dlginfo.softname = "3D Studio";
	MQ_ShowFileDialog("ASC Export", &dlginfo);

	// IuWFNg̐𓾂
	int objcount = doc->GetObjectCount();

	// ̃IuWFNgPɍ邽߂ɁAƗpIuWFNg쐬
	MQObject obj = MQ_CreateObject();

	// ƗpIuWFNgɂׂẴIuWFNg
	for(i=0; i<objcount; i++)
	{
		MQObject thisobj = doc->GetObject(i);
		if(thisobj == NULL) 
			continue;
		// t[YȂǂɂeύXĂ܂̂ŁAIuWFNg𕡐Ă
		thisobj = thisobj->Clone();
		// ȖʂȂǂ̑t[Y
		thisobj->Freeze(MQOBJECT_FREEZE_ALL);
		// ƗpIuWFNgɍ
		obj->Merge(thisobj);
		// IuWFNg͂svȂ̂Ŕj
		thisobj->DeleteThis();
	}

	// ʂƒ_̐擾
	int face_count = obj->GetFaceCount();
	int vert_count = obj->GetVertexCount();

	// ASC`͎Op`Ȃ̂ŁAOp`ʂ͂PAlp`ʂ͂QƂāA
	// o͌̎Opʂ̐𐔂
	int triangle_count = 0;
	for(face_index=0; face_index<face_count; face_index++)
	{
		switch(obj->GetFacePointCount(face_index)){
		case 3: triangle_count++; break;
		case 4: triangle_count+=2; break;
		}
	}

	// t@C̐擪Ƀf[^
	fprintf(fh, "Ambient light color: Red=0.3 Green=0.3 Blue=0.3\n");
	fprintf(fh, "\n");
	fprintf(fh, "Named object: \"\"\n");
	fprintf(fh, "Tri-mesh, Vertices: %d     Faces: %d\n",
		vert_count, triangle_count);

	// 璸_Xg̏
	fprintf(fh, "Vertex list:\n");
	// _̃f[^zƂptsɊi[
	MQPoint *pts = (MQPoint *)malloc(sizeof(MQPoint) * vert_count);
	obj->GetVertexArray(pts);
	// W_CAOŎw肵̂ɕϊ
	MQ_ExportAxis(&dlginfo, pts, vert_count);
	// t@C֏o
	for(i=0; i<vert_count; i++)
		fprintf(fh, "Vertex %d:  X:%.6f     Y:%.6f     Z:%.6f\n",
			i, pts[i].x, pts[i].y, pts[i].z);
	free(pts);

	// ʃXg̏
	fprintf(fh, "Face list:\n");
	triangle_count = 0;
	for(face_index=0; face_index<face_count; face_index++)
	{
		// _CfbNX̔z𓾂
		obj->GetFacePointArray(face_index, index);
		// ގCfbNX𓾂(Fʂ-1Ԃ)
		mat_index = obj->GetFaceMaterial(face_index);
		mat = (mat_index >= 0) ? doc->GetMaterial(mat_index) : NULL;
		// ގ̐F𓾂(Fʂ̏ꍇ͔FZbg)
		if(mat != NULL)
			color = mat->GetColor();
		else
			color = MQColor(1.0f, 1.0f, 1.0f);

		// Op`ʂ͂PAlp`ʂ͂Q̖ʂ
		switch(obj->GetFacePointCount(face_index)){
		case 3:
			fprintf(fh, "Face %d:    A:%d B:%d C:%d AB:1 BC:1 CA:1\n",
				triangle_count++, index[0], index[1], index[2]);
			fprintf(fh, "Material:\"r%dg%db%da%d\"\n", 
				(int)(color.r*255),(int)(color.b*255),(int)(color.b*255),255);
			fprintf(fh, "Smoothing:  1\n");
			break;

		case 4:
			// (0-1-2)𒸓_CfbNXƂOp`̏o
			fprintf(fh, "Face %d:    A:%d B:%d C:%d AB:1 BC:1 CA:1\n",
				triangle_count++, index[0], index[1], index[2]);
			fprintf(fh, "Material:\"r%dg%db%da%d\"\n", 
				(int)(color.r*255),(int)(color.b*255),(int)(color.b*255),255);
			fprintf(fh, "Smoothing:  1\n");
			
			// (0-2-3)𒸓_CfbNXƂOp`̏o
			fprintf(fh, "Face %d:    A:%d B:%d C:%d AB:1 BC:1 CA:1\n",
				triangle_count++, index[0], index[2], index[3]);
			fprintf(fh, "Material:\"r%dg%db%da%d\"\n", 
				(int)(color.r*255),(int)(color.b*255),(int)(color.b*255),255);
			fprintf(fh, "Smoothing:  1\n");

			break;
		}
	}

	// ƗpIuWFNgj
	obj->DeleteThis();

	// t@C̏I[̃f[^
	fprintf(fh, "\n");
	fprintf(fh, "									 Page 1\n");
	fprintf(fh, "\n");

	// t@CN[Y
	fclose(fh);

	return TRUE;
}

