//---------------------------------------------------------------------------
//
//   ExportRIB
//
//          Copyright(C) 1999, O.Mizno
//
//    @RIB(RenderMan)`o͂GNX|[gvOC̃TvB
//    @쐬DLL"Plugins\Export"tH_ɓKvB
//    @RenderManɂ͏ڂȂ̂ŁÃTvł͂܂葽̏o
//@@͂ĂȂB
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "MQPlugin.h"
#include "FileLib.h"

BOOL SaveRIB(const char *filename, MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0xC486EA1D;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "RIB Exporter   Copyright(C) 1999, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// o͗pvOCł
	return MQPLUGIN_TYPE_EXPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "RenderMan (*.rib)";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "rib";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQExportFile
//    [ʖŕۑ]ŕۑƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQExportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return SaveRIB(filename, doc);
	}
	return FALSE;
}

// RIB`ŏo
BOOL SaveRIB(const char *filename, MQDocument doc)
{
	int i, face, mat_index;
	MQMaterial mat;
	MQFileDialogInfo dlginfo;
	char path[MAX_PATH], name[64];

	// Wϊp_CAO̕\
	memset(&dlginfo, 0, sizeof(dlginfo));
	dlginfo.dwSize = sizeof(dlginfo);
	dlginfo.axis_x = MQFILE_TYPE_RIGHT;
	dlginfo.axis_y = MQFILE_TYPE_UP;
	dlginfo.axis_z = MQFILE_TYPE_BACK;
	dlginfo.softname = "RenderMan";
	MQ_ShowFileDialog("RIB Export", &dlginfo);

	// t@C쐬EI[v
	FILE *fh = fopen(filename, "w");
	if(fh == NULL)
		return FALSE;

	// ̃IuWFNgPɍ邽߂ɁAƗpIuWFNg쐬
	MQObject obj = MQ_CreateObject();

	// ƗpIuWFNgɂׂẴIuWFNg
	int objcount = doc->GetObjectCount();
	for(i=0; i<objcount; i++)
	{
		MQObject thisobj = doc->GetObject(i);
		if(thisobj == NULL) 
			continue;
		// t[YȂǂɂeύXĂ܂̂ŁAIuWFNg𕡐Ă
		thisobj = thisobj->Clone();
		// ȖʂȂǂ̑t[Y
		thisobj->Freeze(MQOBJECT_FREEZE_ALL);
		// ƗpIuWFNgɍ
		obj->Merge(thisobj);
		// IuWFNg͂svȂ̂Ŕj
		thisobj->DeleteThis();
	}

	// ʂƒ_̐擾
	int face_count = obj->GetFaceCount();
	int vert_count = obj->GetVertexCount();

	// t@C̐擪Ƀf[^
	fprintf(fh, "##RenderMan RIB-Structure 1.0\n");
	fprintf(fh, "version 3.03\n");
	fprintf(fh, "\n");

	fprintf(fh, "Option \"searchpath\" \"shader\" [\".:&\"]\n");
	GetFileNameFromPath(path, filename);
	fprintf(fh, "Display \"%s.tif\" \"file\" \"rgba\"\n", path);
	fprintf(fh, "Projection \"perspective\" \"fov\" 45\n");
	fprintf(fh, "Translate 0 0 1000\n");
	fprintf(fh, "Rotate 0 0 0 0\n");	
	fprintf(fh, "\n");

	fprintf(fh, "WorldBegin\n");
	fprintf(fh, "\n");
	fprintf(fh, "LightSource \"ambientlight\" 1 \"intensity\" 0.08\n");
	fprintf(fh, "\n");
	fprintf(fh, "Declare \"shadows\" \"string\"\n");
	fprintf(fh, "Attribute \"light\" \"shadows\" \"on\"\n");
	fprintf(fh, "LightSource \"distantlight\" 1 \"from\" [0 1 -4] \"to\" [0 0 0] \"intensity\" 0.8\n");
	fprintf(fh, "\n");

	// ꂼ̍ގ̖ʂɎgĂ邩ǂ𒲂ׂĂ
	int mat_count = doc->GetMaterialCount();
	int *mat_used = (int *)malloc(sizeof(int) * (mat_count+1));
	for(i=0; i<=mat_count; i++)
		mat_used[i] = 0;
	for(face=0; face<face_count; face++)
	{
		mat_index = obj->GetFaceMaterial(face);
		mat_used[(mat_index>=0) ? mat_index : mat_count]++; // Fʂ̏ꍇ͔z̍ŌɃf[^Zbg
	}

	// ގƂAttributeƂă|SL^
	for(mat_index=0; mat_index<=mat_count; mat_index++)
	{
		int mi;

		// ̍ގgĂȂ΃pX
		if(mat_used[mat_index] == 0)
			continue;

		if(mat_index == mat_count) {
			mat = MQ_CreateMaterial(); // Fʂ̏ꍇ͈ꎞIɍގ쐬
			mi = -1;
		} else {
			mat = doc->GetMaterial(mat_index);
			mi = mat_index;
		}
	
		fprintf(fh, "AttributeBegin\n");

		// RgƂčގL^Ă
		mat->GetName(name, sizeof(name));
		fprintf(fh, "#  %s\n", name);

		MQColor color = mat->GetColor();
		fprintf(fh, "  Color  [ %.3f %.3f %.3f ]\n", color.r, color.g, color.b);		

		for(face=0; face<face_count; face++)
		{
			// ̖ʂɊ蓖Ăꂽގ𒲂ׂ
			if(obj->GetFaceMaterial(face) == mi)
			{
				int vert_index[4], vert, count;

				// ʒ̒_ƒ_CfbNX擾
				count = obj->GetFacePointCount(face);
				obj->GetFacePointArray(face, vert_index);

				fprintf(fh, "  Polygon \"P\"  [ ");
				for(vert=0; vert<count; vert++)
				{
					MQPoint p = obj->GetVertex(vert_index[vert]);
					// W_CAOŎw肵̂ɕϊ
					MQ_ExportAxis(&dlginfo, &p, 1);
					fprintf(fh, "%.3f %.3f %.3f ", p.x, p.y, p.z);
				}
				fprintf(fh, "]\n");
			}
		}

		fprintf(fh, "AttributeEnd\n");
		fprintf(fh, "\n");

		// FʗpɈꎞIɍގ폜
		if(mat_index == mat_count)
			mat->DeleteThis();
	}

	// t@C̏I[̃f[^
	fprintf(fh, "WorldEnd\n");
	fprintf(fh, "\n");

	// t@CN[Y
	fclose(fh);

	// svɂȂf[^j
	free(mat_used);
	obj->DeleteThis();

	return TRUE;
}

