//---------------------------------------------------------------------------
//
//   ImportDXF
//
//          Copyright(C) 1999, O.Mizno
//
//    @DXF(AutoCAD)`͂C|[gvOC̃TvB
//    @쐬DLL"Plugins\Import"tH_ɓKvB
//    @DXF`̂b`c̋@\񋟂ĂȂ̂ƁAĎdl̏ڍ
//    mȂ߁ÃTvł͂܂葽̏͂ĂȂB
//    ȂA͒PȂTvłāAMetasequoia̓ɂDXFC|[g
//    @\gݍ܂Ă̂ŁÃvWFNgō쐬vOCg
//    Ӗ͂ȂB
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include "MQPlugin.h"
#include "Strings.h"

BOOL LoadDXF(const char *filename, MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x4E0A0173;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "AutoCAD DXF Importer   Copyright(C) 1999, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// ͗pvOCł
	return MQPLUGIN_TYPE_IMPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "AutoCAD DXF (*.dxf)";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "dxf";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQImportFile
//    [ǂݍ]hbOhbvœǂݍނƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQImportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return LoadDXF(filename, doc);
	}
	return FALSE;
}


// DXF`
BOOL LoadDXF(const char *filename, MQDocument doc)
{
	int index[4], vert_count;
	int sc;
	MQPoint p;

	//DXFt@CI[v
	FILE *fh = fopen(filename, "rb");
	if(fh == NULL)
		return FALSE;

	// Strings.cppŒ`ĂeLXgt@C̓ǂݍݗpNX쐬
	FileStringSeparator *afs = new FileStringSeparator(fh);

	// IuWFNg̍쐬
	MQObject obj = MQ_CreateObject();
	//MQObj_SetName(obj, ""); //̃Tvł͖O͕tȂ̂ŃRgAEg

	for(int count=0; ; count++)
	{
		sc = afs->GetLine();
		if(sc == EOF)break;
		if(sc == 0)continue;

		if(afs->chkcom("3DFACE",1))
		{
			for(vert_count=0;;)
			{
				sc = afs->GetLine();
				if(sc == EOF)break;
				if(sc == 0)continue;

				int comid = afs->ToInt(0);
				switch(comid){
				case 0: //end
					// R_ȏ㒸_΁Aʂǉ
					if(vert_count >= 3)
						obj->AddFace(vert_count, index);
					goto _3DFACE_END;
				case 10:
				case 11:
				case 12:
				case 13:
					sc = afs->GetLine();
					if(sc == EOF) goto _3DFACE_END;
					if(sc > 0)
						p.x = afs->ToFloat(0);
					break;
				case 20:
				case 21:
				case 22:
				case 23:
					sc = afs->GetLine();
					if(sc == EOF) goto _3DFACE_END;
					if(sc > 0)
						p.y = afs->ToFloat(0);
					break;
				case 30:
				case 31:
				case 32:
				case 33:
					sc = afs->GetLine();
					if(sc == EOF) goto _3DFACE_END;
					if(sc > 0)
						p.z = afs->ToFloat(0);
					// _܂So^ĂȂ΁A_ǉ
					if(vert_count < 4)
						index[vert_count++] = obj->AddVertex(p);
					break;
				//case 8: //layer command
				//case 62: //color command
				default:
					// sȃR}h𖳎
					if(afs->GetLine() == EOF) goto _3DFACE_END;
				}
			}
_3DFACE_END:;
		}
	}

	delete afs;

	fclose(fh);

	// ʂ܂o^ĂȂȂFALSEԂ
	if(obj->GetFaceCount() == 0)
	{
		obj->DeleteThis();
		return FALSE;
	}

	// e|S̓ooł邽߁Aʒu(ۂɂ͏_덷l
	// 0.0001ȉ̋)ɂ邷ׂĒ_
	obj->OptimizeVertex(0.0001f, NULL);

	// IuWFNghLg֓o^
	doc->AddObject(obj);

	return TRUE;
}

