//---------------------------------------------------------------------------
//
//   StationSpy
//
//          Copyright(C) 2006-2007, O.Mizno
//
//    @풓vOCɑ郁bZ[WĎ܂BꂽbZ[
//    W̓XgɈꗗ\܂B
//    @풓vOCɂǂ^C~OŃbZ[W邩m
//    FړIłpB
//    @rhɂWTL(Windows Template Library)ʓrKvłB
//
//---------------------------------------------------------------------------
#include "stdafx.h"
#include "resource.h"
#include "maindlg.h"
#include "StationSpyPlugin.h"

static StationSpyPlugin plugin;


// RXgN^
StationSpyPlugin::StationSpyPlugin()
{
	dlgMain = NULL;
	m_bActivate = false;
	m_bOnDraw = false;
	m_bOnUpdateScene = false;
	m_bOnUpdateUndo = false;
}

// RXgN^
StationSpyPlugin::~StationSpyPlugin()
{
	if (dlgMain != NULL){
		// Exit()Ŕj͂ꉞÔ߂ł
		dlgMain->DestroyWindow();
		delete dlgMain;
		dlgMain = NULL;
	}
}

//---------------------------------------------------------------------------
//  GetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
void StationSpyPlugin::GetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x9CE001E3;
}

//---------------------------------------------------------------------------
//  GetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
const char *StationSpyPlugin::GetPlugInName(void)
{
	return "Station Spy       Copyright(C) 2006, O.Mizno";
}

//---------------------------------------------------------------------------
//  EnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
const char *StationSpyPlugin::EnumString(void)
{
	return "Station Spy";
}


//---------------------------------------------------------------------------
//  Initialize
//    AvP[V̏
//---------------------------------------------------------------------------
BOOL StationSpyPlugin::Initialize()
{
	if (dlgMain == NULL){
		// AvP[VɃCEChẼnh蓖
		dlgMain = new CMainDlg(this);
		if(dlgMain->Create(MQ_GetWindowHandle()) == NULL)
		{
			delete dlgMain;
			dlgMain = NULL;
			ATLTRACE(_T("Main dialog creation failed!\n"));
			return 0;
		}

		// EChEɑOʂ
		dlgMain->SetWindowPos(HWND_TOPMOST, 0,0,0,0,SWP_NOMOVE|SWP_NOSIZE|SWP_NOACTIVATE);

		dlgMain->AddMessage("Initialize");
	}
	return TRUE;
}

//---------------------------------------------------------------------------
//  Exit
//    AvP[V̏I
//---------------------------------------------------------------------------
void StationSpyPlugin::Exit()
{
	if (dlgMain != NULL){
		dlgMain->AddMessage("Exit");
		dlgMain->DestroyWindow();
		delete dlgMain;
		dlgMain = NULL;
	}
}

//---------------------------------------------------------------------------
//  Activate
//    \E\؂ւv
//---------------------------------------------------------------------------
BOOL StationSpyPlugin::Activate(MQDocument doc, BOOL flag)
{
	if (dlgMain == NULL)
		return FALSE;

	// EChE̕\E\؂ւ
	m_bActivate = flag ? true : false;
	dlgMain->ShowWindow(m_bActivate ? SW_SHOW : SW_HIDE);

	char buf[256];
	sprintf(buf, "Activate : flag=%s", flag ? "TRUE" : "FALSE");
	dlgMain->AddMessage(buf);

	return m_bActivate;
}

//---------------------------------------------------------------------------
//  IsActivated
//    \E\Ԃ̕ԓ
//---------------------------------------------------------------------------
BOOL StationSpyPlugin::IsActivated(MQDocument doc)
{
	// EChE܂ĂȂȂTRUE
	if (dlgMain == NULL)
		return FALSE;

	return m_bActivate;
}

//---------------------------------------------------------------------------
//  OnMinimize
//    EChE̍ŏւ̕ԓ
//---------------------------------------------------------------------------
void StationSpyPlugin::OnMinimize(MQDocument doc, BOOL flag)
{
	char buf[256];
	sprintf(buf, "OnMinimize : flag=%s", flag ? "TRUE" : "FALSE");
	dlgMain->AddMessage(buf);
}

//---------------------------------------------------------------------------
//  OnReceiveUserMessage
//    vOCƎ̃bZ[W̎󂯎
//---------------------------------------------------------------------------
int StationSpyPlugin::OnReceiveUserMessage(MQDocument doc, DWORD src_product, DWORD src_id, const char *description, void *message)
{
	int len = strlen(description);
	char *buf = (char*)malloc(len + 200);
	sprintf(buf, "OnReceiveUserMessage : src_plugin=[%08x %08x] description=%s", src_product, src_id, description);
	dlgMain->AddMessage(buf);

	// SingleMovevOC̒ʒm̂݁Aʂȓs
	if (src_product == 0x56A31D20 && src_id == 0x3901EA9B){
		if (strcmp(description, "text") == 0){
			sprintf(buf, "  from SingleMove : %s", (const char*)message);
			dlgMain->AddMessage(buf);
		}
	}

	free(buf);

	return 59; // K59ԂĂ
}

//---------------------------------------------------------------------------
//  OnDraw
//    `掞̏
//---------------------------------------------------------------------------
void StationSpyPlugin::OnDraw(MQDocument doc, MQScene scene, int width, int height)
{
	if (!m_bOnDraw)
		return;

	char buf[256];
	sprintf(buf, "OnDraw : width=%d, height=%d", width, height);
	dlgMain->AddMessage(buf);
}


//---------------------------------------------------------------------------
//  OnNewDocument
//    hLg
//---------------------------------------------------------------------------
void StationSpyPlugin::OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param)
{
	char buf[256+MAX_PATH];
	sprintf(buf, "OnNewDocument : filename=%s", (filename!=NULL) ? filename : "(none)");
	dlgMain->AddMessage(buf);
}

//---------------------------------------------------------------------------
//  OnEndDocument
//    hLgI
//---------------------------------------------------------------------------
void StationSpyPlugin::OnEndDocument(MQDocument doc)
{
	dlgMain->AddMessage("OnEndDocument");
}

//---------------------------------------------------------------------------
//  OnSaveDocument
//    hLgۑ
//---------------------------------------------------------------------------
void StationSpyPlugin::OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param)
{
	char buf[256+MAX_PATH];
	sprintf(buf, "OnSaveDocument : filename=%s", (filename!=NULL) ? filename : "(none)");
	dlgMain->AddMessage(buf);
}

//---------------------------------------------------------------------------
//  OnUndo
//    AhDs
//---------------------------------------------------------------------------
BOOL StationSpyPlugin::OnUndo(MQDocument doc, int undo_state)
{
	char buf[256];
	sprintf(buf, "OnUndo : undo_state=%d", undo_state);
	dlgMain->AddMessage(buf);
	
	return FALSE;
}

//---------------------------------------------------------------------------
//  OnRedo
//    hDs
//---------------------------------------------------------------------------
BOOL StationSpyPlugin::OnRedo(MQDocument doc, int redo_state)
{
	char buf[256];
	sprintf(buf, "OnRedo : redo_state=%d", redo_state);
	dlgMain->AddMessage(buf);

	return FALSE;
}

//---------------------------------------------------------------------------
//  OnUpdateUndo
//    AhDԍXV
//---------------------------------------------------------------------------
void StationSpyPlugin::OnUpdateUndo(MQDocument doc, int undo_state, int undo_size)
{
	if (!m_bOnUpdateUndo)
		return;

	char buf[256];
	sprintf(buf, "OnUpdateUndo : undo_state=%d undo_size=%d", undo_state, undo_size);
	dlgMain->AddMessage(buf);
}

//---------------------------------------------------------------------------
//  OnObjectModified
//    IuWFNg̕ҏW
//---------------------------------------------------------------------------
void StationSpyPlugin::OnObjectModified(MQDocument doc)
{
	dlgMain->AddMessage("OnObjectModified");
}

//---------------------------------------------------------------------------
//  OnObjectSelected
//    IuWFNg̑IԂ̕ύX
//---------------------------------------------------------------------------
void StationSpyPlugin::OnObjectSelected(MQDocument doc)
{
	dlgMain->AddMessage("OnObjectSelected");
}

//---------------------------------------------------------------------------
//  OnUpdateObjectList
//    JgIuWFNg̕ύX
//---------------------------------------------------------------------------
void StationSpyPlugin::OnUpdateObjectList(MQDocument doc)
{
	dlgMain->AddMessage("OnUpdateObjectList");
}

//---------------------------------------------------------------------------
//  OnMaterialModified
//    }eÃp[^ύX
//---------------------------------------------------------------------------
void StationSpyPlugin::OnMaterialModified(MQDocument doc)
{
	dlgMain->AddMessage("OnMaterialModified");
}

//---------------------------------------------------------------------------
//  OnUpdateMaterialList
//    Jg}eA̕ύX
//---------------------------------------------------------------------------
void StationSpyPlugin::OnUpdateMaterialList(MQDocument doc)
{
	dlgMain->AddMessage("OnUpdateMaterialList");
}

//---------------------------------------------------------------------------
//  OnUpdateScene
//    V[̕ύX
//---------------------------------------------------------------------------
void StationSpyPlugin::OnUpdateScene(MQDocument doc, MQScene scene)
{
	if (!m_bOnUpdateScene)
		return;

	dlgMain->AddMessage("OnUpdateScene");
}

//---------------------------------------------------------------------------
//  ExecuteCallback
//    R[obNɑ΂
//---------------------------------------------------------------------------
bool StationSpyPlugin::ExecuteCallback(MQDocument doc, void *option)
{
	CallbackInfo *info = (CallbackInfo*)option;
	return ((*this).*info->proc)(doc);
}

// R[obŇĂяo
void StationSpyPlugin::Execute(ExecuteCallbackProc proc)
{
	CallbackInfo info;
	info.proc = proc;
	BeginCallback(&info);
}

// vOC̃x[XNXԂ
MQBasePlugin *GetPluginClass()
{
	return &plugin;
}

