#ifndef _WTL_TEST_PLUGIN_H_
#define _WTL_TEST_PLUGIN_H_

#include "MQBasePlugin.h"

class WTLTestPlugin : public MQStationPlugin
{
	friend class CMainDlg;

protected:
	CMainDlg *dlgMain;
	bool m_bActivate;

public:
	bool m_bShowLocal;

public:
	WTLTestPlugin();
	virtual ~WTLTestPlugin();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName(void);
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(void);

	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();

	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// \E\Ԃ̕ԓ
	virtual BOOL IsActivated(MQDocument doc);

	// hLg
	void OnNewDocument(MQDocument doc, const char *filename, NEW_DOCUMENT_PARAM& param);
	// hLgۑ
	void OnSaveDocument(MQDocument doc, const char *filename, SAVE_DOCUMENT_PARAM& param);
	// `掞̏
	void OnDraw(MQDocument doc, MQScene scene, int width, int height);
	// IuWFNg̕ҏW
	virtual void OnObjectModified(MQDocument doc);
	// JgIuWFNg̕ύX
	virtual void OnUpdateObjectList(MQDocument doc);


	typedef bool (WTLTestPlugin::*ExecuteCallbackProc)(MQDocument doc);

	void Execute(ExecuteCallbackProc proc);

	// ʂ̍폜
	bool DeleteFace(MQDocument doc);

protected:
	struct CallbackInfo {
		ExecuteCallbackProc proc;
	};

	virtual bool ExecuteCallback(MQDocument doc, void *option);
};


#endif _WTL_TEST_PLUGIN_H_
