//---------------------------------------------------------------------------
//
//   Wired
//
//          Copyright(C) 1999, O.Mizno
//
//    @IuWFNg̕ӂ݂̂cĖʂ폜IuWFNgvOC̃TvB
//    @쐬DLL"Plugins\Object"tH_ɓKvB
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "MQPlugin.h"

BOOL Wired(MQDocument doc);
BOOL DeleteLines(MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x157E8FB0;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "Wired           Copyright(C) 1999, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// IuWFNgό`pvOCł
	return MQPLUGIN_TYPE_OBJECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "Wired";
	case 1: return "Delete lines";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQModifyObject
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifyObject(int index, MQDocument doc)
{
	switch(index){
	case 0: return Wired(doc);
	case 1: return DeleteLines(doc);
	}
	return FALSE;
}

class EdgeHash
{
public:
	int vertex;
	EdgeHash *next;

	EdgeHash(int v) {
		vertex = v;
		next = NULL;
	}
	virtual ~EdgeHash() {
		if(next != NULL)
			delete next;
	}
	void Add(EdgeHash *hash) {
		if(next != NULL)
			next->Add(hash);
		else
			next = hash;
	}
	EdgeHash *Search(int v)
	{
		if(v == vertex)
			return this;
		if(next != NULL)
			return next->Search(v);
		return NULL;
	}
};

//C[
BOOL Wired(MQDocument doc)
{
	int obj_index, face_count, vert_count;
	int face, vert, vert_index[4];
	EdgeHash **edge;

	// JgIuWFNg̎擾
	obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)
		return FALSE;
	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)
		return FALSE;

	face_count = obj->GetFaceCount();
	vert_count = obj->GetVertexCount();

	// GbWp̃nbV
	edge = (EdgeHash **)malloc(sizeof(EdgeHash *) * vert_count);
	for(vert=0; vert<vert_count; vert++)
		edge[vert] = NULL;

	// ӂ̃f[^ۑĂ
	for(face=0; face<face_count; face++)
	{
		int i,v1,v2;
		int count = obj->GetFacePointCount(face);
		if(count == 0) continue;

		obj->GetFacePointArray(face, vert_index);

		switch(count){
		case 2:
			v1 = min(vert_index[0], vert_index[1]);
			v2 = max(vert_index[0], vert_index[1]);
			if(edge[v1] != NULL) {
				if(edge[v1]->Search(v2) == NULL)
					edge[v1]->Add(new EdgeHash(v2));
			} else
				edge[v1] = new EdgeHash(v2);
			break;
		case 3:
		case 4:
			for(i=0; i<count; i++)
			{
				v1 = min(vert_index[i], vert_index[(i+1)%count]);
				v2 = max(vert_index[i], vert_index[(i+1)%count]);
				if(edge[v1] != NULL) {
					if(edge[v1]->Search(v2) == NULL)
						edge[v1]->Add(new EdgeHash(v2));
				} else
					edge[v1] = new EdgeHash(v2);
			}
			break;
		}
	}

	// Co^
	for(vert=0; vert<vert_count; vert++)
	{
		vert_index[0] = vert;
		for(EdgeHash *ce=edge[vert]; ce!=NULL; ce=ce->next)
		{
			vert_index[1] = ce->vertex;
			obj->AddFace(2, vert_index);
		}
	}

	// IWi̖ʂ폜
	for(face=0; face<face_count; face++)
		obj->DeleteFace(face);

	// IuWFNgRpNg
	obj->Compact();

	// nbV폜
	for(vert=0; vert<vert_count; vert++) {
		if(edge[vert] != NULL)
			delete edge[vert];
	}
	free(edge);
	
	return TRUE;
}

//C̏
BOOL DeleteLines(MQDocument doc)
{
	int obj_index, face_count, face;
	char buf[64];

	// JgIuWFNg̎擾
	obj_index = doc->GetCurrentObjectIndex();
	if(obj_index < 0)
		return FALSE;
	MQObject obj = doc->GetObject(obj_index);
	if(obj == NULL)
		return FALSE;

	// IuWFNg̖ʐ擾
	face_count = obj->GetFaceCount();

	int count = 0;
	for(face=0; face<face_count; face++)
	{
		// w肵ʂ2̒_ɂč\A܂胉Cł
		// 
		if(obj->GetFacePointCount(face) == 2){
			obj->DeleteFace(face);
			count++;
		}
	}

	if(count == 0)
	{
		MessageBox(MQ_GetWindowHandle(), "No lines in current object.",
			"Delete lines", MB_OK|MB_ICONINFORMATION);
		return FALSE;
	}

	obj->Compact();

	sprintf(buf, "%d lines deleted.", count);
	MessageBox(MQ_GetWindowHandle(), buf, "Delete lines", MB_OK|MB_ICONINFORMATION);
	
	return TRUE;
}

