//---------------------------------------------------------------------------
//
//   Measure
//
//          Copyright(C) 1999, O.Mizno
//
//    @IC̒𑪂IvOC̃TvB
//    @쐬DLL"Plugins\Select"tH_ɓKvB
//
//
//---------------------------------------------------------------------------

#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <math.h>
#include "MQPlugin.h"

BOOL MeasureLength(MQDocument doc);


//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x1E53AC5F;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "Measure           Copyright(C) 1999, O.Mizno";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// I𕔕ό`pvOCł
	return MQPLUGIN_TYPE_SELECT;
}

//---------------------------------------------------------------------------
//  MQEnumString
//    |bvAbvj[ɕ\镶ԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumString(int index)
{
	switch(index){
	case 0: return "Measure length of lines";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQModifySelect
//    j[IꂽƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQModifySelect(int index, MQDocument doc)
{
	switch(index){
	case 0: return MeasureLength(doc);
	}
	return FALSE;
}

//̌v
BOOL MeasureLength(MQDocument doc)
{
	MQSelectLine sel;
	int vert[4];
	MQPoint vec;
	float length = 0.0f;
	char buf[64];

	int obj_count = doc->GetObjectCount();

	// IuWFNg̐JԂ
	for(sel.object=0; sel.object<obj_count; sel.object++)
	{
		MQObject obj = doc->GetObject(sel.object);
		if(obj == NULL)
			continue;

		// IuWFNg̖ʐ(mɂ͔z̑傫)𓾂
		int face_count = obj->GetFaceCount();

		for(sel.face=0; sel.face<face_count; sel.face++)
		{
			// Ȗ(_̎QƐ0)ȂpX
			int ptcount = obj->GetFacePointCount(sel.face);
			if(ptcount == 0)
				continue;

			// C̒v
			if(ptcount >= 3) {
				for(sel.line=0; sel.line<ptcount; sel.line++)
					if(doc->IsSelectLine(sel)) {
						obj->GetFacePointArray(sel.face, vert);
						vec = obj->GetVertex(vert[sel.line])
						    - obj->GetVertex(vert[(sel.line+1)%ptcount]);
						length += (float)sqrt(vec.x*vec.x + vec.y*vec.y + vec.z*vec.z);
					}
			} else if(ptcount == 2) {
				sel.line = 0;
				if(doc->IsSelectLine(sel)) {
					obj->GetFacePointArray(sel.face, vert);
					vec = obj->GetVertex(vert[0])
					    - obj->GetVertex(vert[1]);
					length += (float)sqrt(vec.x*vec.x + vec.y*vec.y + vec.z*vec.z);
				}
			}
		}
	}

	// ̕\
	sprintf(buf, "Length = %.2f", length);
	MessageBox(MQ_GetWindowHandle(), buf, "Measure", MB_OK);
	
	return TRUE;
}

