//---------------------------------------------------------------------------
//
//   Single Move
//
//          Copyright(C) 2007, O.Mizno
//
//    @P̒_ړR}hvOC̃TvB
//    @쐬DLL"Plugins\Command"tH_ɓKvB
//    @vOCCXg["Single Move"{^
//    R}hplɒǉ܂B
//
//
//---------------------------------------------------------------------------
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <float.h>
#include "MQBasePlugin.h"
#include "resource.h"

HINSTANCE g_hInstance;


class SingleMovePlugin : public MQCommandPlugin
{
public:
	// RXgN^
	SingleMovePlugin();

	// vOCIDԂB
	virtual void GetPlugInID(DWORD *Product, DWORD *ID);
	// vOCԂB
	virtual const char *GetPlugInName(void);
	// |bvAbvj[ɕ\镶ԂB
	virtual const char *EnumString(void);
	// AvP[V̏
	virtual BOOL Initialize();
	// AvP[V̏I
	virtual void Exit();
	// \E\؂ւv
	virtual BOOL Activate(MQDocument doc, BOOL flag);
	// `掞̏
	virtual void OnDraw(MQDocument doc, MQScene scene, int width, int height);

	// {^ꂽƂ
	virtual BOOL OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^Ȃ}EXړƂ
	virtual BOOL OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// {^ꂽƂ
	virtual BOOL OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);
	// }EXړƂ
	virtual BOOL OnMouseMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state);

private:
	int m_iHighlightObject;
	int m_iHighlightVertex;
	int m_iMoveObject;
	int m_iMoveVertex;
	bool m_bMoved;
	MQPoint m_ScreenPos;
	MQPoint m_MovedPos;

	HCURSOR m_MoveCursor;
};



//---------------------------------------------------------------------------
//  SingleMovePlugin::SingleMovePlugin
//    RXgN^
//---------------------------------------------------------------------------
SingleMovePlugin::SingleMovePlugin()
{
	m_iHighlightObject = -1;
	m_iHighlightVertex = -1;
	m_iMoveObject = -1;
	m_iMoveVertex = -1;
	m_bMoved = false;

	m_MoveCursor = NULL;
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::GetPlugInID
//    vOCIDԂB
//---------------------------------------------------------------------------
void SingleMovePlugin::GetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0x56A31D20;
	*ID      = 0x3901EA9B;
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::GetPlugInName
//    vOCԂB
//---------------------------------------------------------------------------
const char *SingleMovePlugin::GetPlugInName(void)
{
	return "Single Move       Copyright(C) 2007, O.Mizno";
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::EnumString
//    {^ɕ\镶ԂB
//---------------------------------------------------------------------------
const char *SingleMovePlugin::EnumString(void)
{
	return "Single Move";
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::Initialize
//    AvP[V̏
//---------------------------------------------------------------------------
BOOL SingleMovePlugin::Initialize()
{
	// J[\[h
	if(m_MoveCursor == NULL){
		m_MoveCursor = LoadCursor(g_hInstance, MAKEINTRESOURCE(IDC_CURSOR1));
	}

	return TRUE;
}

//---------------------------------------------------------------------------
//  SingleMovePlugin::Exit
//    AvP[V̏I
//---------------------------------------------------------------------------
void SingleMovePlugin::Exit()
{
	// ɉȂ
}

//---------------------------------------------------------------------------
//  SingleMovePlugin::Activate
//    \E\؂ւv
//---------------------------------------------------------------------------
BOOL SingleMovePlugin::Activate(MQDocument doc, BOOL flag)
{
	if (!flag){
		// nCCg\
		if (m_iHighlightObject != -1 && m_iHighlightVertex != -1){
			m_iHighlightObject = -1;
			m_iHighlightVertex = -1;
			RedrawAllScene();
		}
	}
	
	// ̂܂flagԂ
	return flag;
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::OnDraw
//    `掞̏
//---------------------------------------------------------------------------
void SingleMovePlugin::OnDraw(MQDocument doc, MQScene scene, int width, int height)
{
	// _nCCg`
	if (m_iHighlightObject != -1 && m_iHighlightVertex != -1)
	{
		MQObject obj = doc->GetObject(m_iHighlightObject);
		if (obj == NULL) return; // 蓾Ȃ͂AÔNULL`FbN

		// _ʒuvZ
		MQPoint sp = scene->Convert3DToScreen(obj->GetVertex(m_iHighlightVertex));
		MQPoint newvp = scene->ConvertScreenTo3D(MQPoint(sp.x,sp.y,0.00001f)); // Oɕ`悷邽Zɂق0ivZ덷h߁jZbg

		// `IuWFNg𐶐
		int vertex[1];
		MQObject draw = CreateDrawingObject(doc, DRAW_OBJECT_POINT);
		draw->SetColor(MQColor(1,1,0));
		draw->SetColorValid(TRUE);
		vertex[0] = draw->AddVertex(newvp);
		draw->AddFace(1, vertex);
	}
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::OnLeftButtonDown
//    {^ꂽƂ
//---------------------------------------------------------------------------
BOOL SingleMovePlugin::OnLeftButtonDown(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	MQPoint clickpos(state.MousePos.x, state.MousePos.y, 0);
	float mindis2 = 10*10; //10sNZȓ

	// ҏWIvV擾
	EDIT_OPTION option;
	GetEditOption(option);

	m_iMoveObject = -1;
	m_iMoveVertex = -1;
	m_bMoved = false;

	// NbNꂽʒuɍł߂_
	int numObj = doc->GetObjectCount();
	for (int oi=0; oi<numObj; oi++)
	{
		MQObject obj = doc->GetObject(oi);
		if (obj == NULL) continue;

		// \܂̓bNĂΑΏۊO
		if (!obj->GetVisible() || obj->GetLocking()) continue;

		// JgIuWFNĝݕҏW
		if (option.CurrentObjectOnly && oi != doc->GetCurrentObjectIndex())
			continue;

		int numVertex = obj->GetVertexCount();
		for (int vi=0; vi<numVertex; vi++)
		{
			if (obj->GetVertexRefCount(vi) != 0)
			{
				// NbNꂽʒuɋ߂ǂ
				MQPoint sp = scene->Convert3DToScreen(obj->GetVertex(vi));
				float dis2 = (sp.x-clickpos.x)*(sp.x-clickpos.x) + (sp.y-clickpos.y)*(sp.y-clickpos.y);
				if (mindis2 > dis2){
					// ̒_ړΏۂ
					mindis2 = dis2;
					m_iMoveObject = oi;
					m_iMoveVertex = vi;
					m_ScreenPos = sp;
				}
			}
		}
	}

	// W̑ɓƎŝTRUEԂ
	return TRUE;
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::OnLeftButtonMove
//    {^Ȃ}EXړƂ
//---------------------------------------------------------------------------
BOOL SingleMovePlugin::OnLeftButtonMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	if (m_iMoveObject != -1 && m_iMoveVertex != -1)
	{
		MQObject obj = doc->GetObject(m_iMoveObject);
		if (obj == NULL) return TRUE; // 蓾Ȃ͂AÔNULL`FbN

		// ҏWIvV擾
		EDIT_OPTION option;
		GetEditOption(option);

		// _ړiXN[WZ͂̂܂܂X/Ŷݓj
		MQPoint vp = scene->ConvertScreenTo3D(MQPoint(state.MousePos.x, state.MousePos.y, m_ScreenPos.z));
		if (option.SnapGrid){
			// Obhւ̋z
			vp = GetSnappedPos(scene, vp, option.SnapGrid);
		}
		obj->SetVertex(m_iMoveVertex, vp);

		// ĕ`
		RedrawScene(scene);

		// ړς݃`FbN
		m_bMoved = true;
		m_MovedPos = vp;
	}

	// W̑ɓƎŝTRUEԂ
	return TRUE;
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::OnLeftButtonUp
//    {^ꂽƂ
//---------------------------------------------------------------------------
BOOL SingleMovePlugin::OnLeftButtonUp(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	if (m_iMoveObject != -1 && m_iMoveVertex != -1 && m_bMoved)
	{
		// _ړꂽꍇAĕ`ƃAhD̍XVs
		RedrawAllScene();
		UpdateUndo();

		// StationSpyvOCɃbZ[W𑗂
		char buf[128];
		sprintf(buf, "Moved to (%.3f %.3f %.3f)", m_MovedPos.x, m_MovedPos.y, m_MovedPos.z);
		int ret = SendUserMessage(doc, 0x56A31D20, 0x9CE001E3, "text", buf);
		sprintf(buf, "Received %d from SendUserMessage()\n", ret);
		OutputDebugString(buf);
	}

	// W̑ɓƎŝTRUEԂ
	return TRUE;
}


//---------------------------------------------------------------------------
//  SingleMovePlugin::OnMouseMove
//    }EXړƂ
//---------------------------------------------------------------------------
BOOL SingleMovePlugin::OnMouseMove(MQDocument doc, MQScene scene, MOUSE_BUTTON_STATE& state)
{
	float mindis2 = 10*10; //10sNZȓ

	int newoi = -1;
	int newvi = -1;

	// ҏWIvV擾
	EDIT_OPTION option;
	GetEditOption(option);

	// NbNꂽʒuɍł߂_
	int numObj = doc->GetObjectCount();
	for (int oi=0; oi<numObj; oi++)
	{
		MQObject obj = doc->GetObject(oi);
		if (obj == NULL) continue;

		// \܂̓bNĂΑΏۊO
		if (!obj->GetVisible() || obj->GetLocking()) continue;

		// JgIuWFNĝݕҏW
		if (option.CurrentObjectOnly && oi != doc->GetCurrentObjectIndex())
			continue;

		int numVertex = obj->GetVertexCount();
		for (int vi=0; vi<numVertex; vi++)
		{
			if (obj->GetVertexRefCount(vi) != 0)
			{
				// NbNꂽʒuɋ߂ǂ
				MQPoint sp = scene->Convert3DToScreen(obj->GetVertex(vi));
				float dis2 = (sp.x-state.MousePos.x)*(sp.x-state.MousePos.x) + (sp.y-state.MousePos.y)*(sp.y-state.MousePos.y);
				if (mindis2 > dis2){
					// ̒_ړΏۂ
					mindis2 = dis2;
					newoi = oi;
					newvi = vi;
				}
			}
		}
	}

	// OƈႤ_ɃJ[\ꍇ͍ĕ`
	if (m_iHighlightObject != newoi || m_iHighlightVertex != newvi)
	{
		m_iHighlightObject = newoi;
		m_iHighlightVertex = newvi;

		if(m_iHighlightVertex != -1){
			SetMouseCursor(m_MoveCursor);
		}else{
			SetMouseCursor(GetResourceCursor(MQCURSOR_DEFAULT));
		}
		RedrawScene(scene);
	}

	// ƎsAWs킹邽FALSEԂ
	return FALSE;
}



//---------------------------------------------------------------------------
//  GetPluginClass
//    vOC̃x[XNXԂ
//---------------------------------------------------------------------------
MQBasePlugin *GetPluginClass()
{
	static SingleMovePlugin plugin;
	return &plugin;
}



//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HINSTANCE hinstDLL, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	if(ul_reason_for_call == DLL_PROCESS_ATTACH){
		g_hInstance = hinstDLL;
	}
    return TRUE;
}

